/*
 * Softcam plugin to VDR (C++)
 *
 * This code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * Or, point your browser to http://www.gnu.org/copyleft/gpl.html
 */

// This files contains some option switches/values for compile time
// configuration of the plugin.
//
// After changing this file you should do a "make plugins-clean ; make plugins"
// to recompile vdr.

#ifndef ___CONFIG_H
#define ___CONFIG_H

#define ECM_TRY_COUNT   6    // try to get a key X times from the same ECM pid
#define PAT_TRY_COUNT   5    // try to find PMT pid in X PAT pakets
#define PMT_TRY_COUNT   5    // try to read PMT X times
#define CW_REPEAT_TIME  2000 // rewrite CW after X ms
#define LOG_COUNT       3
#define MIN_CHANGE_TIME 120  // min. time (s) between changes of the ca-sys of the logger
#define CA_SEARCH_TIME  15   // reload PAT/PMT after X s, if no ca-sys is found
#define GETCA_TIMEOUT   5000 // ms, timeout to allow vdr collect caDescriptors

#define READ_TIMEOUT    500  // ms, default read timeout for demux device
#define NOSYNC_TIMEOUT  800  // ms, read timeout before a valid key is found
#define SYNC_TIMEOUT    2000 // ms, read timeout when a valid key is found
#define PARSE_TIMEOUT   2000 // ms, read timeout for parsing tables

#define KEYFILE         "SoftCam.Key"
#define CACACHE_FILE    "ca.cache"

// Debugging
#define DEBUG
//#define DEBUG_TURN
//#define DEBUG_COND
//#define DEBUG_KEYS
#define DEBUG_LOG
#define DEBUG_LOG_FILE "/var/tmp/logger.log"
//#define PAT_DUMP "/var/tmp/pat.dump"
//#define PMT_DUMP "/var/tmp/pmt.dump"
//#define ECM_DUMP "/var/tmp/ecm.dump"
//#define CAT_DUMP "/var/tmp/cat.dump"
//#define EMM_DUMP "/var/tmp/emm.dump"

#endif //___CONFIG_H
