	
#include <stdio.h>
#include <unistd.h>
#include <assert.h>
#include <fcntl.h>
#include <ctype.h>
#include <pthread.h>

#include "types.h"

#include "sio.h"
#include "iso.h"
#include "camcrypt.h"
#include "betacam.h"



static uchar prid00[3]				= {0};
static uchar prid10[3]				= {0};
static uchar HEXSerial[8]			= {0};
static uchar HEXBase					=  0;
static ushort ACS							=  0x384;
static ushort CAID						=  0;
static uchar ASCIISerial[11]	= {0};
static uchar CamKey[]					= { 0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77, 0x88 };
static pthread_mutex_t mp;




//Plain:		 80 00 00 00 00 00 00 00 11 22 33 44 55 66 77 88 11 22 33 44 55 66 77 88 12 34 56 78 90 AB CD EF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF 00<03>
//Answer		= B2 08 3D F0 09 A6 9F 56 
//CamKEY		= 11 22 33 44 55 66 77 88 
//Encrypted: 18 D7 55 14 C0 83 F1 38 39 6F F2 EC 4F E3 F1 85 01 46 06 CE 7D 08 2C 74 46 8F 72 C4 EA D7 9C E0 E1 FF 58 E7 70 0C 92 45 26 18 4F A0 E2 F5 9E 46 6F AE 95 35 B0 49 B2 0E A4 1F 8E 47 D0 24 11 D0<12> 

ISOCmd cGetCountryCode[] =		{ 0x01, 0x02, 0x02, 0x00, 0x00, 0x00};

ISOCmd cGetCamKey384CZ[] =    { 0x01, 0x02, 0x09, 0x03, 0x00, 0x40, 
																0x18, 0xD7, 0x55, 0x14, 0xC0, 0x83, 0xF1, 0x38, 
																0x39, 0x6F, 0xF2, 0xEC, 0x4F, 0xE3, 0xF1, 0x85, 
																0x01, 0x46, 0x06, 0xCE, 0x7D, 0x08, 0x2C, 0x74, 
																0x46, 0x8F, 0x72, 0xC4, 0xEA, 0xD7, 0x9C, 0xE0, 
																0xE1, 0xFF, 0x58, 0xE7, 0x70, 0x0C, 0x92, 0x45, 
																0x26, 0x18, 0x4F, 0xA0, 0xE2, 0xF5, 0x9E, 0x46, 
																0x6F, 0xAE, 0x95, 0x35, 0xB0, 0x49, 0xB2, 0x0E, 
																0xA4, 0x1F, 0x8E, 0x47, 0xD0, 0x24, 0x11, 0xD0 };

ISOCmd cGetCamKey384DZ[] =    { 0x01, 0x02, 0x09, 0x03, 0x00, 0x40, 
																0x27, 0xF2, 0xD6, 0xCD, 0xE6, 0x88, 0x62, 0x46, 
																0x81, 0xB0, 0xF5, 0x3E, 0x6F, 0x13, 0x4D, 0xCC, 
																0xFE, 0xD0, 0x67, 0xB1, 0x93, 0xDD, 0xF4, 0xDE, 
																0xEF, 0xF5, 0x3B, 0x04, 0x1D, 0xE5, 0xC3, 0xB2, 
																0x54, 0x38, 0x57, 0x7E, 0xC8, 0x39, 0x07, 0x2E, 
																0xD2, 0xF4, 0x05, 0xAA, 0x15, 0xB5, 0x55, 0x24, 
																0x90, 0xBB, 0x9B, 0x00, 0x96, 0xF0, 0xCB, 0xF1, 
																0x8A, 0x08, 0x7F, 0x0B, 0xB8, 0x79, 0xC3, 0x5D };

ISOCmd cGetCamKey383C[]  =    { 0x01, 0x02, 0x09, 0x03, 0x00, 0x40, 
																0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77, 0x88,
																0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77, 0x88,
																0x11, 0x22, 0x33, 0x44, 0x55, 0x66, 0x77, 0x88, 
																0x12, 0x34, 0x56, 0x78, 0x90, 0xAB, 0xCD, 0xEF, 
																0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 
																0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 
																0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 
																0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF };


ISOCmd cGetASCIISerial[] =		{ 0x01, 0x02, 0x00, 0x03, 0x00, 0x00};

ISOCmd cGetHEXSerial[] =			{ 0x01, 0x02, 0x01, 0x00, 0x00, 0x00};

ISOCmd cGetCountryCode2[] =		{ 0x01, 0x02, 0x0B, 0x00, 0x00, 0x00};

ISOCmd cGetProvider00[] =			{ 0x01, 0x02, 0x03, 0x03, 0x00, 0x00};

ISOCmd cGetProvider00A[] =		{ 0x01, 0x02, 0x03, 0x03, 0x01, 0x00};

ISOCmd cGetProvider10[] = 		{ 0x01, 0x02, 0x03, 0x03, 0x02, 0x00};

ISOCmd cGetProvider10A[] =		{ 0x01, 0x02, 0x03, 0x03, 0x03, 0x00};

ISOCmd cGetCardFile2[] =  		{ 0x01, 0x02, 0x0E, 0x02, 0x00, 0x00};

ISOCmd cGetCardFile3[] =			{ 0x01, 0x02, 0x0E, 0x03, 0x00, 0x00};


static int betacam_cardinit(void)
{
	int received;
	uchar ReceiveBuffer[MAX_LEN+1];

	if (i_reset(ReceiveBuffer)) {
		return 0;
	}

	pthread_mutex_lock(&mp);

	// es sollte eigentlich noch getestet werden, ob der ATR OK ist...
	if (ReceiveBuffer[0] != 0x3B &&
			ReceiveBuffer[1] != 0x9f) { 
		Log("ATR kaputt!\n");
	}

	/*********************************************************************
		GetCountryCode
	*********************************************************************/
	received = i_DoCmd(cGetCountryCode, ReceiveBuffer, 200);			
	if (received != 25 ||
			ReceiveBuffer[8]  != 0x03)
	{
		Log("Error: cGetCountryCode\n");
	}
	ACS = ReceiveBuffer[8];
	ACS <<= 8;
	ACS += ReceiveBuffer[9];
	Log ("ACS Version: %04X\n", ACS);

	CAID = (ushort)ReceiveBuffer[13];
	CAID <<= 8;
	CAID += (ushort)ReceiveBuffer[14];
	Log ("CA-ID= 0x%04X\n", CAID);


	/*********************************************************************
		GetASCIISerial
	*********************************************************************/
	received = i_DoCmd(cGetASCIISerial, ReceiveBuffer, 200);
	if (received  == 29) {
		memcpy (ASCIISerial, &ReceiveBuffer[8], 10);
		Log("\nASCII Serial: %10s\n", ASCIISerial);
	} else {
		Log("Error: cGetASCIISerial\n");
	}

	/*********************************************************************
		GetHEXSerial
	*********************************************************************/
	received = i_DoCmd(cGetHEXSerial, ReceiveBuffer, 200);
	if (received == 25) {
		// das hier zu lange kopieren geht nur, da der ReceiveBuffer immer aussreichend ist
		memcpy(HEXSerial, &ReceiveBuffer[20], 8);
		HEXBase = ReceiveBuffer[23];
		Log("\nHEX Serial: %02X%02X%02X  HEX Base: %02X\n", HEXSerial[0], HEXSerial[1], HEXSerial[2], HEXBase);
	} else {
		Log("Error: cGetHEXSerial\n");
	}

	/*********************************************************************
		GetProv00
	*********************************************************************/
	received = i_DoCmd(cGetProvider00, ReceiveBuffer, 200);
	if (received == 33) {
		memcpy (prid00, &ReceiveBuffer[9], 3);
	} else {
		Log("Error: cGetProvider00\n");
	}

	/*********************************************************************
		GetProv10
	*********************************************************************/
	received = i_DoCmd(cGetProvider10, ReceiveBuffer, 200);
	if (received == 33) {
		memcpy (prid10, &ReceiveBuffer[9], 3);
	} else {
		Log("Error: cGetProvider10\n");
	}

	/*********************************************************************
		GetCardfile2
	*********************************************************************/
	received = i_DoCmd(cGetCardFile2, ReceiveBuffer, 200);

	/*********************************************************************
		GetCardfile3
	*********************************************************************/
	received = i_DoCmd(cGetCardFile3, ReceiveBuffer, 200);

	/*********************************************************************
		GetCAMKey
	*********************************************************************/

	if (ACS == 0x383) {
		received = i_DoCmd(cGetCamKey383C, ReceiveBuffer, 200);				
		if (ReceiveBuffer[2] != 0x55) {
			Log ("ACS 3.83: CAMKEY Error\n");
		} else {
			Log ("ACS 3.83: CAMKEY OK\n");
		}
	} else {
		if (CAID == 0x1702) {
			received = i_DoCmd(cGetCamKey384CZ, ReceiveBuffer, 200);		
		} else {
			received = i_DoCmd(cGetCamKey384DZ, ReceiveBuffer, 200);		
		}
		if (received != 17) {
			Log ("ACS 3.84: CAMKEY Error\n");
		} else {
			Log ("ACS 3.84: CAMKEY OK\n");
		}
	}

	Log ("Camkey: ");
	Dump(CamKey, 8);
	Log ("\n");
	
	pthread_mutex_unlock(&mp);
	return 0;
}


int betacam_init(char *device)
{
  static isInit = 0;
// ToDo: pthread um Kartenstatus zu pollen (1s?)
  if (isInit) return 1;
  if(i_iso_open(device)) return 1;
  isInit = 1;
  pthread_mutex_init(&mp, NULL);
	return betacam_cardinit();
}


static int betacam_checkhealth(void)
{ 
#if 0
	static int ReInitNeeded = 0;

  if (!i_card_inserted()) {
		ReInitNeeded = 1;
		return 0;
  } 
	if (ReInitNeeded) {
		ReInitNeeded = 0;
		betacam_cardinit();
  }
#endif	
	return 1;
}


int betacam_emm(uchar *emm)
{
	uchar emmheader[] = { 0x01, 0x01, 0x00, 0x00, 0x00 };
	uchar emmbuffer[MAX_LEN+1];
	uchar ReceiveBuffer[MAX_LEN+1];
	int len;


  if(!betacam_checkhealth()) {
    return 0;
  }

	assert(emm[0] == 0x82);

  pthread_mutex_lock(&mp);

	if ((emm[3] & 0xf8) != (HEXBase * 8)) {
		// keine gueltige HEX Adressierung
		pthread_mutex_unlock(&mp);
		return  0;
	}

#if 0
	if ((emm[3] & 0x07) == 3) {
		Log("3 Byte EMM:\n");
	  len = emm[2] + 3;
		Dump(emm, len);
		Log("\n");
	}
#endif

	if (emm[3] & 0x07) {
		if (memcmp (&emm[4], HEXSerial, emm[3] & 0x07)) {
			pthread_mutex_unlock(&mp);
			return 0;  // Falls nicht die passende Serial
		} 
	}


	Log("\nEMM: %d byte adressed \n", emm[3] & 0x07);


  len = emm[2] + 3;
  Dump(emm, len);
	memcpy (emmbuffer, emmheader, sizeof (emmheader));
	memcpy (emmbuffer + sizeof (emmheader), &emm[2], len-2);

	i_DoCmd((ISOCmd*)emmbuffer, ReceiveBuffer, MAX_LEN);

	Dump(&ReceiveBuffer, ReceiveBuffer[7]+7);

	pthread_mutex_unlock(&mp);
	return 1;
}


// Liefert '1' zurueck, wenn CW gueltig
int betacam_ecm(uchar *ecm, uchar *cw)
{
	int i, result = 0;
	const uchar ecmheader[]	= {0x01, 0x05, 0x00, 0x00, 0x02 };
	uchar ReceiveBuffer[MAX_LEN+1];

  static uchar ecmbuffer[BETACAMMAXB][BETACAMECMSTORE];
  static uchar cwbuffer[BETACAMMAXB][16];
  static int rotate;
  uchar aecm[4096];

  if(!betacam_checkhealth()) {
    return 0;
  }

	pthread_mutex_lock(&mp);

	for(i=0;i<BETACAMMAXB;i++) {
		if (!memcmp((uchar *)ecmbuffer[i],ecm,BETACAMECMSTORE)) {
      memcpy(cw,cwbuffer[i],16);
			pthread_mutex_unlock(&mp);
      return 1;
     }
  }

	Log("ECM:\n");
	Dump(ecm, ecm[2] + 3);

	memcpy(aecm,ecm,ecm[2] + 3);
	ecm[5] = ecm[2] - 3;
	memcpy (ecm, ecmheader, sizeof (ecmheader));
	if (i_DoCmd((ISOCmd*)ecm, ReceiveBuffer, 200) >= BETACAMECMSTORE) {
    if (ReceiveBuffer[2] == 0x9d) {
			ReverseSessionKeyCrypt(CamKey, &ReceiveBuffer[14]);
			Log("\nCW1/2:\n");
			Dump(&ReceiveBuffer[14], 8);
			ReverseSessionKeyCrypt(CamKey, &ReceiveBuffer[22]);
			Dump(&ReceiveBuffer[22], 8);
			memcpy(cw, &ReceiveBuffer[14], 16);
			result=1;
			memcpy(ecmbuffer[rotate],aecm, BETACAMECMSTORE);
			memcpy(cwbuffer[rotate],cw,16);
			rotate++;
			if ( rotate >= BETACAMMAXB)  {
				rotate=0;
			}
		} 
	}

	pthread_mutex_unlock(&mp);
	return result;
}


ushort betacam_getcaid(void)
{
  return CAID;
}
