#include <stdio.h>
#include <assert.h>
#include <stdarg.h>
#include <time.h>

#include "logger.h"


#ifdef LOGFILE

static FILE *logfile = NULL;

static void InitLog(void) 
{
  if (!logfile) {
    logfile = fopen (LOGFILE, "a");
    if (!logfile ) {
      logfile = (FILE*)-1;
      fprintf (stderr, "couldn't open Logile: %s\n", LOGFILE);
    } else {    
      time_t ltime;
      time( &ltime );
      fprintf (logfile , "\n\nLogfile started: %s\n", ctime(&ltime));
    }
  }
}

void Log(char *fmt,...)
{
  int i = 2;

  if (logfile == 0) {
    InitLog();
  }
  if (logfile > 0) {
    va_list params;  
    va_start(params, fmt);     
    vfprintf(logfile, fmt, params);   
//    vprintf(fmt, params);   
    va_end(params);  
    fflush(logfile);
  }
}


void Dump(unsigned char *ptr, int len)
{
  int counter = 0;
  if (logfile == 0) {
    InitLog();
  }
  if (logfile > 0) {
    fprintf (logfile, "\nDatasize: %d\n", len);
    while (counter++ < len) {
      fprintf(logfile, "%02X ", *ptr++);
      if ((counter%8) == 0) {
        fprintf(logfile, "\n");
      }
    }
    fflush(logfile);
  } 
}

void CloseLog(void) 
{
	fclose (logfile);
}

#else  // LOGFILE

// Dummy implementation
void Log(char *fmt,...) {};
void Dump(unsigned char *ptr, int len) {};
void CloseLog(void) {};
#endif // LOGFILE
