#ifndef _NAGRA_H
#define _NAGRA_H

#include <openssl/bn.h>

bool Nagra_RSADecrypt_ECM(unsigned char *data, int keyselect, int pecmlen, BIGNUM * e1, BIGNUM * n1, BIGNUM * n2);
int Nagra_RSADecrypt_EMM(unsigned char *data, unsigned char *signature, int keyselect, unsigned char *vkey, int emmlen, BIGNUM * e1, BIGNUM * n1, BIGNUM * n2);
int Nagra_GetKeys(unsigned char *_decodedEMM, unsigned char *_provider, unsigned char *_key0, unsigned char *_key1);
bool Nagra_SigCheck(unsigned char *block, unsigned char *sig, unsigned char *vkey, int rounds);
void Nagra_Decrypt(const unsigned char *_data, const unsigned char *_key, unsigned char *_decrypted);
void RotateBytes(unsigned char *in, int count);
void Nagra_KeyCrypt(const unsigned char *_data, const unsigned char *_key, unsigned char *out);
void Nagra_Hash(const unsigned char *_data, unsigned char *_hash, int rounds);

void FreeRoms(void);
void SetRomDir(const char *romdir);

#endif /* _NAGRA_H */
