/*
 * Softcam plugin to VDR (C++)
 *
 * This code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * Or, point your browser to http://www.gnu.org/copyleft/gpl.html
 */

#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>

#include "common.h"
#include "logger-betacam.h"
#include "logger.h"
#include "softcam.h"
#include "data.h"
#include "misc.h"


#include "libbetacam/logger.h"
#include "libbetacam/betacam.h"

// -- cLogBetaCam ------------------------------------------------------------------

cLogBetaCam::cLogBetaCam(int CardNum)
:cLogSys(CardNum)
{
  lastKey=0;
}

bool cLogBetaCam::HaveCards(void)
{
  return true;
}

bool cLogBetaCam::LoadCards(const char *cfgdir)
{	
  return true;
}


int cLogBetaCam::ParseCAT(unsigned char *buffer, int n, int sys, int id)
{
#ifdef BETACAM_SUPPORT
	if ((unsigned short)betacam_getcaid() != sys) {
		::Log("\ncLogBetaCam::ParseCAT: %08X\n wrong CAID(OK)", sys);
		return -1;
	}
#endif
  for(int index=8 ; index<n ;) {
    if(buffer[index]==0x09) {
      int s=WORD(buffer,index+2,0xFFFF);
      if(sys==s)  {
#ifdef BETACAM_SUPPORT
				::Log("\ncLogBetaCam::ParseCAT - CAID: 0x%04X pid: 0x%04X - EMM pid acceptet\n", sys, WORD(buffer,index+4,0x1FFF));
#endif 
				return WORD(buffer,index+4,0x1FFF);
			}
    }
    index+=buffer[index+1]+2;
  }
  return -1;
}

int cLogBetaCam::Section(void)
{
  return 0x82;
}

void cLogBetaCam::Log(unsigned char *buffer, int n)
{
#ifdef BETACAM_SUPPORT
	betacam_emm(buffer);
#endif  //BETACAM_SUPPORT	
}
