/*
 * Softcam plugin to VDR (C++)
 *
 * This code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * Or, point your browser to http://www.gnu.org/copyleft/gpl.html
 */

#ifndef ___MISC_H
#define ___MISC_H

#include <stdio.h>
#include <vdr/thread.h>
#include "common.h"

// ----------------------------------------------------------------

#define KeyStr(str,key) HexStr(str,key,8)

void SetFilter(int fd, int pid, bool crc, int tnr, int mask, int buffSize);
void StopFilter(int fd);
int TimedRead(int fd, unsigned char *buffer, int length, int timeout);
int ReadPaket(int fd, unsigned char *buffer, int length, int timeout=READ_TIMEOUT);
const char *HexStr(char *str, const unsigned char *mem, int len);
int GetHex(char * &line, unsigned char *store, int count, bool fixedLen=true);
int GetHexAsc(char * &line, unsigned char *store, int count);
int GetChar(char * &line, int *store, int count);
int Bin2Int(unsigned char *mem, int len);

void Dump(const char *name, unsigned char *buffer, int n);
void HexDump(unsigned char *buffer, int n);

FILE *LogStart(const char *name=0);
void LogEnd(FILE *f);

// ----------------------------------------------------------------

class cRunMode {
private:
  cMutex runModeMutex;
  cCondVar runModeCond;
#ifdef DEBUG_COND
  char module[24];
#endif
protected:
  enum eRunMode { rmRun, rmChange, rmStop, rmStartup, rmKilled };
  eRunMode runMode;
  //
  void SetRunMode(eRunMode mode);
  void WaitRunMode(eRunMode mode, bool inv, unsigned long timeout=0);
public:
  cRunMode(const char *Module, const int Card);
  };

#endif //___MISC_H
