/*
 * Softcam plugin to VDR (C++)
 *
 * This code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * Or, point your browser to http://www.gnu.org/copyleft/gpl.html
 */

#include <vdr/channels.h>

#include "common.h"
#include "status.h"
#include "softcam.h"

// -- cScStatus ----------------------------------------------------------------

void cScStatus::ChannelSwitch(const cDevice *device, int chNumber)
{
  if(chNumber>0) {
    cChannel *channel=Channels.GetByNumber(chNumber);
    if(channel && channel->Ca()>MAXDVBAPI) {
      cSoftCAM *cam=cSoftCAM::FindCAM(device);
      if(!cam) cam=cSoftCAM::Init(device);
      if(cam) cam->SetChannel(channel->Sid(),channel->Source(),channel->Frequency());
      }
    else {
      cSoftCAM *cam=cSoftCAM::FindCAM(device);
      if(cam) cam->SetChannel(0);
      }
    }
}

void cScStatus::Recording(const cDevice *device, const char *name)
{
  cSoftCAM *cam=cSoftCAM::FindCAM(device);
  if(cam && cam->CurrentPrg()) {
    if(!name && cDevice::PrimaryDevice()!=device && !device->Receiving())
      cam->SetChannel(-1);
    }
}
